.386
.model flat,stdcall
option casemap:none

include RunasLSA.inc

.data

CLSID_CTaskScheduler    GUID sCLSID_CTaskScheduler
IID_ITaskScheduler      GUID sIID_ITaskScheduler
IID_ITask               GUID sIID_ITask

; fill the structure AT_INFO to create a scheduled job

_at_info    dd 0        ; JobTime
            dd 0        ; DaysOfMonth
            db 0        ; DaysOfWeek
            db 0        ; Flags
            dw 0        ; alignment bytes
            dd OFFSET command1

WSTR        command1,"Cmd.exe"

; jobs created with the scheduler API have the name AtXX
; XX = ID of the job

WSTR        JobToRun,"At"
            db 0,0,0,0

WSTR        format1,"%u"

.data?

pITS        dd ?
pITask      dd ?
JobID       dd ?
buffer      db 10 dup(?)

.code

start:

; create the scheduled job

    invoke  NetScheduleJobAdd,0,ADDR _at_info,ADDR JobID

; get the name of the job

    invoke  wsprintfW,ADDR buffer,ADDR format1,JobID
    invoke  lstrcatW,ADDR JobToRun,ADDR buffer
    
; initialize COM

    invoke  CoInitialize,NULL

; create an uninitialized object of the class TaskScheduler

    invoke  CoCreateInstance,ADDR CLSID_CTaskScheduler,NULL,\ 
            CLSCTX_INPROC_SERVER,ADDR IID_ITaskScheduler,ADDR pITS

; return an interface to ITask

    push    OFFSET pITask
    push    OFFSET IID_ITask
    push    OFFSET JobToRun
    mov     eax,pITS
    push    eax
    mov     eax,DWORD PTR [eax]
    call    ITaskScheduler.Activate[eax]

; release the pointer

    mov     eax,pITS
    push    eax
    mov     eax,DWORD PTR [eax]
    call    ITaskScheduler.IUnknown.Release[eax]

; run the scheduled task

    mov     eax,pITask
    push    eax
    mov     eax,DWORD PTR [eax]
    call    IScheduledWorkItem.Run[eax]

    mov     eax,pITask
    push    eax
    mov     eax,DWORD PTR [eax]
    call    IScheduledWorkItem.IUnknown.Release[eax]

; wait before the scheduler service runs the job and after delete the job

    invoke  Sleep,1000
    invoke  NetScheduleJobDel,0,JobID,JobID

; all finished with COM

    invoke  CoUninitialize
    invoke  ExitProcess,0

END start

