include     \masm32\include\windows.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\user32.inc
include     \masm32\include\ole32.inc
include     \masm32\include\netapi32.inc

include     \masm32\macros\ucmacros.asm

includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\ole32.lib
includelib  \masm32\lib\netapi32.lib

; Methods of the IUnknown interface

UNKNOWN STRUCT

    QueryInterface          dd ?
    AddRef                  dd ?
    Release                 dd ?

UNKNOWN ENDS

; Methods of the ITaskScheduler interface

ITaskScheduler STRUCT

    IUnknown                UNKNOWN <>
    SetTargetComputer       dd ?
    GetTargetComputer       dd ?
    Enum                    dd ?
    Activate                dd ?
    Delete                  dd ?
    NewWorkItem             dd ?
    AddWorkItem             dd ?
    IsOfType                dd ?
    
ITaskScheduler ENDS

; Methods of the IScheduledWorkItem interface

IScheduledWorkItem STRUCT

    IUnknown                UNKNOWN <>
    CreateTrigger           dd ?
    DeleteTrigger           dd ?
    GetTriggerCount         dd ?
    GetTrigger              dd ?
    GetTriggerString        dd ?
    GetRunTimes             dd ?
    GetNextRunTime          dd ?
    SetIdleWait             dd ?
    GetIdleWait             dd ?
    Run                     dd ?
    Terminate               dd ?
    EditWorkItem            dd ?
    GetMostRecentRunTime    dd ?
    GetStatus               dd ?
    GetExitCode             dd ?
    SetComment              dd ?
    GetComment              dd ?
    SetCreator              dd ?
    GetCreator              dd ?
    SetWorkItemData         dd ?
    GetWorkItemData         dd ?
    SetErrorRetryCount      dd ?
    GetErrorRetryCount      dd ?
    SetErrorRetryInterval   dd ?
    GetErrorRetryInterval   dd ?
    SetFlags                dd ?
    GetFlags                dd ?
    SetAccountInformation   dd ?
    GetAccountInformation   dd ?

IScheduledWorkItem ENDS

; Methods of the ITask interface

ITask STRUCT

    IScheduledWorkItem_     IScheduledWorkItem <>
    SetApplicationName      dd ?
    GetApplicationName      dd ?
    SetParameters           dd ?
    GetParameters           dd ?
    SetWorkingDirectory     dd ?
    GetWorkingDirectory     dd ?
    SetPriority             dd ?
    GetPriority             dd ?
    SetTaskFlags            dd ?
    GetTaskFlags            dd ?
    SetMaxRunTime           dd ?
    GetMaxRunTime           dd ?
    
ITask ENDS


sCLSID_CTaskScheduler       TEXTEQU <{148BD52Ah,0A2ABh,11CEh,{0B1h,01Fh,0h,0AAh,0h,53h,5h,3h}}>
sIID_ITaskScheduler         TEXTEQU <{148BD527h,0A2ABh,11CEh,{0B1h,01Fh,0h,0AAh,0h,53h,5h,3h}}>
sIID_ITask                  TEXTEQU <{148BD524h,0A2ABh,11CEh,{0B1h,01Fh,0h,0AAh,0h,53h,5h,3h}}>



